#include <Servo.h>
//Servomotoren
Servo zeigeFingerBot;
Servo mittelFingerBot;
Servo ringFingerBot;
int papier = 1;
int schere = 2;
int stein = 3;
int zustand;
int play; 
unsigned long zeit1=0;
unsigned long zeit2=0;

//Piezo
int piezo=8;
  
//Getriebemotor richtungen
#define STOP 0
#define VORWAERTS    1
#define RUECKWAERTS   2
#define CS_THRESHOLD 15   // Definition of safety current (Check: "1.3 Monster Shield Example").
//Getriebemotor Pins
#define MOTOR_ZURUECK_PIN 5
#define MOTOR_VOR_PIN 6
#define GESCHWINDIGKEIT_MOTOR_1 7
#define CURRENT_SEN_1 A2
#define EN_PIN_1 A0
#define MOTOR_1 0
short usSpeed = 255;  //default motor speed
unsigned short richtung = STOP;

//Handschuh
int zeigeFinger=A3;// DMS am Zeigefinger
int ringFinger=A5;//DMS am Ringfinger
int schnitt=0;//Variable zum speichern einer Durchschnittsmessung
int ruheschnittZeige=0;// DS Zeigefinger ungeknickt 
int ruheschnittRing=0;// DS Ringfinger ungeknickt
//String zustand;
int punkteBot;//speichert wer gewonnen hat
int punkteSpieler;  


//Handschuh____

void durchschnitt(int n, int pin)//Methode welche eine bestimmte Anzahl an Messungen an einem DMS durchführt und den Durchschnitt ermittelt
{
  for(int i=0;i<n;i++)
  {
    schnitt = schnitt+analogRead(pin);
  }
  schnitt= schnitt/n;
}

void schereSteinPapier()
{
  durchschnitt(30,zeigeFinger);// Sowohl am Ring als auch Zeigefinger wird eine weitere Durchschnittsspannung ermittelt. 
  int tempZeigeSchnitt= schnitt;
  durchschnitt(30,ringFinger);
  int tempRingSchnitt= schnitt;
  if(tempZeigeSchnitt<ruheschnittZeige+5 && tempRingSchnitt<ruheschnittRing+3)// Diese Spannungen werden mit den Spannungen im ungeknickten Modus verglichen und abhängig davon wird das eingetroffene Ergebnis gespeichert
  {
    zustand = papier;
    Serial.println("Du hast Papier"); 
  }
  if(tempZeigeSchnitt<ruheschnittZeige+5 && tempRingSchnitt>=ruheschnittRing+3)
  {
    zustand = schere;
    Serial.println("Du hast Schere");  
  }
  if(tempZeigeSchnitt>=ruheschnittZeige+5 && tempRingSchnitt>=ruheschnittRing+3)
  {
    zustand = stein;
    Serial.println("Du hast Stein");
  }
}

void schereSteinCheat()
{
  durchschnitt(30,zeigeFinger);// Sowohl am Ring als auch Zeigefinger wird eine weitere Durchschnittsspannung ermittelt. 
  int tempZeigeSchnitt= schnitt;
  durchschnitt(30,ringFinger);
  int tempRingSchnitt= schnitt;
  if(tempZeigeSchnitt<ruheschnittZeige+5 && tempRingSchnitt<ruheschnittRing+3)// Diese Spannungen werden mit den Spannungen im ungeknickten Modus verglichen und abhängig davon wird das eingetroffene Ergebnis gespeichert
  {
    zustand = papier;
    Serial.print("Ich habe Schere,        "); 
  }
  if(tempZeigeSchnitt<ruheschnittZeige+5 && tempRingSchnitt>=ruheschnittRing+3)
  {
    zustand = schere;
    Serial.print("Ich habe Stein,        ");  
  }
  if(tempZeigeSchnitt>=ruheschnittZeige+5 && tempRingSchnitt>=ruheschnittRing+3)
  {
    zustand = stein;
    Serial.print("Ich habe Papier,        ");
  }
}

void spielstart()//
{
  int tempZeigeSchnitt;
  int tempRingSchnitt;
  zeit1 = millis();
  do
  {
   durchschnitt(100,zeigeFinger);
   tempZeigeSchnitt= schnitt;
   durchschnitt(100,ringFinger);
   tempRingSchnitt= schnitt;  
  }while(tempZeigeSchnitt<ruheschnittZeige+15 || tempRingSchnitt<ruheschnittRing+15);// Erst wenn Zeigefinger und Ringfinger geknickt sind wird der Spielstart(signalisiert durch ein spezielles Lichtsignal)eingeleitet   
   zeit2 = millis();
   Serial.println(tempZeigeSchnitt);
   Serial.println(tempRingSchnitt);
}

void vergleich(int spieler,int bot)//Methode zum vergleichen des eigenen Ereignisses und dem gegnerischen Ereignis.
{
  if(spieler != bot)
  {
    if((bot==stein && spieler==schere) || (bot==schere && spieler==papier) || (bot==papier && spieler==stein))
    {
      punkteBot++;
    }
    else if((spieler==stein && bot==schere) || (spieler==schere && bot==papier) || (spieler==papier && bot==stein))
    {
      punkteSpieler++;
    }
  }
  else if(spieler==bot)
  {
    Serial.println("Tie");
  }
  Serial.print("Spieler: \t");
  Serial.println(punkteSpieler);
  Serial.print("Bot: \t\t");
  Serial.println(punkteBot);
}

void vergleichCheat()
{
  punkteBot++;
  Serial.print("Spieler: \t");
  Serial.println(punkteSpieler);
  Serial.print("Bot: \t\t");
  Serial.println(punkteBot);
}

void bo1sieger()//Bekanntgebung des Siegers durch Melodie
{
  if(punkteSpieler > punkteBot)//der Spieler hat gewonnen
  {
    Serial.println("Mein/e Gegenspieler/in hat gewonnen");
    moll();
  }
  else if(punkteBot > punkteSpieler)
  { 
    Serial.println("Ich habe gewonnen");
    dur();
  }
  else if(punkteSpieler == punkteBot)
  {
    Serial.println("Unentschieden");
    tone(piezo,200);
    delay(1500);
    noTone(piezo);
  }
}

//Piezo____

void moll()
{
  tone(piezo,349);
  delay(200);
  tone(piezo,294);
  delay(200);
  tone(piezo,220);
  delay(500);
  noTone(piezo);
  delay(1000);
}

void dur()
{
  tone(piezo,262);
  delay(200);
  tone(piezo,294);   
  delay(200);
  tone(piezo,330);
  delay(200);
  tone(piezo,349);   
  delay(200);
  tone(piezo,392);   
  delay(200);
  tone(piezo,440);   
  delay(200);
  tone(piezo,494);   
  delay(200);
  tone(piezo,523);   
  delay(200);
  noTone(piezo);
  delay(1000);
}

//Servo____

void randoM(int zahl)//vergleich mit der random variable und ausübung des Ereignisses.
{
  if(zahl == schere)
  {
    mittelFingerBot.write(0);
    zeigeFingerBot.write(0);
    Serial.print("Ich habe Schere,        ");
  }
  else if(zahl == papier)
  {
    mittelFingerBot.write(0);
    ringFingerBot.write(0);
    zeigeFingerBot.write(0); 
    Serial.print("Ich habe Papier,         ");
  }
  else if(zahl == stein)
  {
    Serial.print("Ich habe Stein,        ");
  }
}

void cheat()
{
  if(zustand == papier)
  {
    mittelFingerBot.write(0);
    zeigeFingerBot.write(0);
    Serial.println("Du hast Papier");
  }
  else if(zustand == schere)
  {
    Serial.println("Du hast Schere");
  }
  else if(zustand == stein)
  {
    mittelFingerBot.write(0);
    ringFingerBot.write(0);
    zeigeFingerBot.write(0); 
    Serial.println("Du hast Stein");
  }
}

//Getriebe___

void armPlay()//bewegung des Arms 
{
  for(int i=0;i<2;i++)
  {
    Forward();
    delay(200);
    Reverse();
    delay(250);
  }
  Forward();
  delay(220);
  Stop();
}

void armBase()
{
  Reverse();
  delay(175);
  Stop();
  delay(100);
  ringFingerBot.write(90);
  delay(100);
  zeigeFingerBot.write(80);//Finger in Stein-Ausrichtung
  mittelFingerBot.write(80);
}

void Stop()
{
  richtung = STOP;//richtung wird auf 0 gesetzt
  motorGo(MOTOR_1, richtung, 0);//drehgeschwindigkeit wird auf 0 gesetzt und somit ein Stop bewirkt.
}

void Forward()
{
  richtung = VORWAERTS;// richtung wird auf vorwärts gesetzt
  motorGo(MOTOR_1, richtung, usSpeed);// drehgeschwindigkeit auf Usspeed
}

void Reverse()
{
  richtung = RUECKWAERTS;
  motorGo(MOTOR_1, richtung, usSpeed);
}

void motorGo(uint8_t motor, uint8_t direct, uint8_t pwm)//je nach Richtung werden entsprechende Pins aktiviert oder deaktiviert       
{
  if (direct == VORWAERTS)
  {
    digitalWrite(MOTOR_ZURUECK_PIN, LOW);
    digitalWrite(MOTOR_VOR_PIN, HIGH);
  }
  else if (direct == RUECKWAERTS)
  {
    digitalWrite(MOTOR_ZURUECK_PIN, HIGH);
    digitalWrite(MOTOR_VOR_PIN, LOW);
  }
  else
  {
    digitalWrite(MOTOR_ZURUECK_PIN, HIGH);
    digitalWrite(MOTOR_VOR_PIN, HIGH);
  }
  analogWrite(GESCHWINDIGKEIT_MOTOR_1, pwm);
}

//Setup___

void setup() 
{
  Serial.begin(9600);
  delay(5000);
  //Servo
  zeigeFingerBot.attach(2);
  mittelFingerBot.attach(3);
  ringFingerBot.attach(4);
  //Getriebe
  pinMode(MOTOR_ZURUECK_PIN, OUTPUT);
  pinMode(MOTOR_VOR_PIN, OUTPUT);
  pinMode(GESCHWINDIGKEIT_MOTOR_1, OUTPUT);
  pinMode(CURRENT_SEN_1, OUTPUT);
  pinMode(EN_PIN_1, OUTPUT);
  //Handschuh
  durchschnitt(80,zeigeFinger);// Es werden 30 Messungen des Zeigefinger dms durchgeführt und in ruheschnittZeige gespeichert
  ruheschnittZeige = schnitt;
  durchschnitt(80,ringFinger);// Hier passiert das gleiche für den Ringfinger
  ruheschnittRing = schnitt;
  Serial.print("Die Durchschnittsspannung von oben beträgt");//Hier Erfolgt eine kurze Ausgabe über die Durchschnittsspannung
  Serial.println(ruheschnittZeige);
  Serial.print("Die Durchschnittsspannung von unten beträgt");
  Serial.println(ruheschnittRing); 
}

//LOOP_____

void loop() 
{
  armBase();
  punkteBot=0;//Punkte auf 0 
  punkteSpieler=0;
  spielstart();
  if(zeit2-zeit1<5000)
  {
    tone(piezo,440);
    delay(1000);
    noTone(piezo);
    Serial.println("Es geht Los");
    zustand = 0;
    play = random(1,4);//randomZahl zur Ereigniss"auswahl"
    armPlay();
    randoM(play);//Ausübung des Ereignisses
    delay(500);
    schereSteinPapier();//Einlesesn des gegnerischen Ereignisses.
    vergleich(zustand,play);//Vergleich der Ereignisse
    bo1sieger();
    delay(3000);
  }
  else if(zeit2-zeit1>5000)
  { 
    tone(piezo,440);
    delay(1000);
    noTone(piezo);
    Serial.println("Es geht Los <-,->");
    zustand = 0;
    armPlay();
    delay(75);
    schereSteinCheat();//Einlesesn des gegnerischen Ereignisses.
    cheat();
    vergleichCheat();
    bo1sieger();
    delay(3000);
  }
}

